import { useReducer } from 'react';
import { nextState } from '../util/StateHelper';

const initialState = {
  gamesList: null,

  newGame: {
    whitePlayer: '',
    blackPlayer: '',
    message2opponent: '',
  },

  proposal: {
    selectedUUID: null,
    message2opponent: '',
  },

  // Network
  isPollingGamesList: false,
  isPushingNewGame: false,

  findGame,
};

function reducer(state, action) {
  switch (action.type) {

    case 'next':
      return nextState(state, action);

    case 'nextNewGame':
      return {
        ...state,
        newGame: nextState(state.newGame, action)
      };

    case 'nextProposal':
      return {
        ...state,
        proposal: nextState(state.proposal, action)
      };

    default:
      throw Error('GamesReducer: unknown action.type', action.type);
  }
}

export default function useGamesReducer() {
  return useReducer(reducer, initialState);
}

function findGame({uuid}) {
  return this.gamesList?.find((game) => game.uuid === uuid);
}